@if "%1"=="test" echo off

:: Clean out if told to.

if not "%1"=="clean" goto noclean
	set tdszweb_now=
	set tdszweb_onedayago=
	set tdszweb_onemonthago=
	set tdszweb_oneyearago=
	set tdszweb_startthismonth=
	set tdszweb_startthisyear=
	set tdszweb_startlastmonth=
	set tdszweb_startlastyear=
	set tdszweb_endthismonth=
	set tdszweb_endthisyear=
	set tdszweb_endlastmonth=
	set tdszweb_endlastyear=
	goto :eof
:noclean

if not "%1"=="test" goto notest
	call :testall
	goto :eof
:notest

:: Get handy individual date and time fields.

for /f "skip=2 tokens=2-7 delims=," %%A in ('wmic path win32_localtime get day^,hour^,minute^,month^,second^,year^ /format:csv') do (
	set /a tdszt_date = 10000 * %%F + 100 * %%D + %%A
	set /a tdszt_time = 10000 * %%B + 100 * %%C + %%E
)
call :expand8 tdszt_date %tdszt_date%
call :expand6 tdszt_time %tdszt_time%

set tdszt_yyyy=%tdszt_date:~0,4%
set tdszt_mm=%tdszt_date:~4,2%
set tdszt_dd=%tdszt_date:~6,2%
set tdszt_h=%tdszt_time:~0,2%
set tdszt_m=%tdszt_time:~2,2%
set tdszt_s=%tdszt_time:~4,2%

set tdszt_date=
set tdszt_time=

call :set_now
call :set_onedayago
call :set_onemonthago
call :set_oneyearago
call :set_startthismonth
call :set_startthisyear
call :set_startlastmonth
call :set_startlastyear
call :set_endthismonth
call :set_endthisyear
call :set_endlastmonth
call :set_endlastyear

set tdszt_yyyy=
set tdszt_mm=
set tdszt_dd=
set tdszt_h=
set tdszt_m=
set tdszt_s=

goto :eof

::=============================================================================
:set_now
	set tdszweb_now=%tdszt_yyyy%%tdszt_mm%%tdszt_dd%%tdszt_h%%tdszt_m%%tdszt_s%
	goto :eof

::=============================================================================
:set_onedayago
	if "%tdszt_dd%"=="01" goto set_onedayago_a
	call :sub2_1 tdszt_dd2 %tdszt_dd%
	set tdszweb_onedayago=%tdszt_yyyy%%tdszt_mm%%tdszt_dd2%%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_dd2=
	goto :eof
:set_onedayago_a
	if "%tdszt_mm%"=="01" goto set_onedayago_b
	call :sub2_1 tdszt_mm2 %tdszt_mm%
	call :daysinmonth tdszt_dd2 %tdszt_yyyy% %tdszt_mm2%
	set tdszweb_onedayago=%tdszt_yyyy%%tdszt_mm2%%tdszt_dd2%%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_dd2=
	set tdszt_mm2=
	goto :eof
:set_onedayago_b
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_onedayago=%tdszt_yyyy2%1231%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_onemonthago
	if "%tdszt_mm%"=="01" goto set_onemonthago_a
	call :sub2_1 tdszt_mm2 %tdszt_mm%
	call :daysinmonth tdszt_dd2 %tdszt_yyyy% %tdszt_mm2%
	if %tdszt_dd2% gtr %tdszt_dd% set tdszt_dd2=%tdszt_dd%
	set tdszweb_onemonthago=%tdszt_yyyy%%tdszt_mm2%%tdszt_dd2%%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_dd2=
	set tdszt_mm2=
	goto :eof
:set_onemonthago_a
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_onemonthago=%tdszt_yyyy2%12%tdszt_dd%%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_oneyearago
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	call :daysinmonth tdszt_dd2 %tdszt_yyyy2% %tdszt_mm%
	if %tdszt_dd2% gtr %tdszt_dd% set tdszt_dd2=%tdszt_dd%
	set tdszweb_oneyearago=%tdszt_yyyy2%%tdszt_mm%%tdszt_dd2%%tdszt_h%%tdszt_m%%tdszt_s%
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_startthismonth
	set tdszweb_startthismonth=%tdszt_yyyy%%tdszt_mm%01000000
	goto :eof

::=============================================================================
:set_startthisyear
	set tdszweb_startthisyear=%tdszt_yyyy%0101000000
	goto :eof

::=============================================================================
:set_startlastmonth
	if "%tdszt_mm%"=="01" goto set_startlastmonth_a
	call :sub2_1 tdszt_mm2 %tdszt_mm%
	set tdszweb_startlastmonth=%tdszt_yyyy%%tdszt_mm2%01000000
	set tdszt_mm2=
	goto :eof
:set_startlastmonth_a
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_startlastmonth=%tdszt_yyyy2%1201000000
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_startlastyear
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_startlastyear=%tdszt_yyyy2%0101000000
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_endthismonth
	call :daysinmonth tdszt_dd2 %tdszt_yyyy% %tdszt_mm%
	set tdszweb_endthismonth=%tdszt_yyyy%%tdszt_mm%%tdszt_dd2%235959
	set tdszt_dd2=
	goto :eof

::=============================================================================
:set_endthisyear
	set tdszweb_endthisyear=%tdszt_yyyy%1231235959
	goto :eof

::=============================================================================
:set_endlastmonth
	if "%tdszt_mm%"=="01" goto set_endlastmonth_a
	call :sub2_1 tdszt_mm2 %tdszt_mm%
	call :daysinmonth tdszt_dd2 %tdszt_yyyy% %tdszt_mm2%
	set tdszweb_endlastmonth=%tdszt_yyyy%%tdszt_mm2%%tdszt_dd2%235959
	set tdszt_dd2=
	set tdszt_mm2=
	goto :eof
:set_endlastmonth_a
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_endlastmonth=%tdszt_yyyy2%1231235959
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:set_endlastyear
	call :sub4_1 tdszt_yyyy2 %tdszt_yyyy%
	set tdszweb_endlastyear=%tdszt_yyyy2%1231235959
	set tdszt_yyyy2=
	goto :eof

::=============================================================================
:daysinmonth
	set %1=31
	if "%3"=="04" set %1=30
	if "%3"=="06" set %1=30
	if "%3"=="09" set %1=30
	if "%3"=="11" set %1=30
	if not "%3"=="02" goto :eof
	set %1=28
	set tdszt_tmp2=%2
	set /a "tdszt_tmp1=tdszt_tmp2%%400"
	if "%tdszt_tmp1%"=="0" goto daysinmonth_29days
	set /a "tdszt_tmp1=tdszt_tmp2%%100"
	if "%tdszt_tmp1%"=="0" goto :daysinmonth_28days
	set /a "tdszt_tmp1=tdszt_tmp2%%4"
	if not "%tdszt_tmp1%"=="0" goto :daysinmonth_28days
:daysinmonth_29days
	set %1=29
:daysinmonth_28days
	set tdszt_tmp1=
	set tdszt_tmp2=
	goto :eof

::=============================================================================
:expand2
	set tdszt_expand2_p1=00%2
	set %1=%tdszt_expand2_p1:~-2%
	set tdszt_expand2_p1=
	goto :eof

::=============================================================================
:expand4
	set tdszt_expand4_p1=0000%2
	set %1=%tdszt_expand4_p1:~-4%
	set tdszt_expand4_p1=
	goto :eof

::=============================================================================
:expand6
	set tdszt_expand6_p1=000000%2
	set %1=%tdszt_expand6_p1:~-6%
	set tdszt_expand6_p1=
	goto :eof

::=============================================================================
:expand8
	set tdszt_expand8_p1=00000000%2
	set %1=%tdszt_expand8_p1:~-8%
	set tdszt_expand8_p1=
	goto :eof

::=============================================================================
:sub2_1
	set tdszt_sub2_1_p1=%2
	call :expand2 tdszt_sub2_1_p1 %tdszt_sub2_1_p1%
	if "%tdszt_sub2_1_p1:~0,1%"=="0" set tdszt_sub2_1_p1=%tdszt_sub2_1_p1:~1,2%
	set /a "tdszt_sub2_1_p1=tdszt_sub2_1_p1-1"
	call :expand2 tdszt_sub2_1_p1 %tdszt_sub2_1_p1%
	set %1=%tdszt_sub2_1_p1%
	set tdszt_sub2_1_p1=
	goto :eof

::=============================================================================
:sub4_1
	set tdszt_sub4_1_p1=%2
	call :expand4 tdszt_sub4_1_p1 %tdszt_sub4_1_p1%
	if "%tdszt_sub4_1_p1:~0,1%"=="0" set tdszt_sub4_1_p1=%tdszt_sub4_1_p1:~1,4%
	if "%tdszt_sub4_1_p1:~0,1%"=="0" set tdszt_sub4_1_p1=%tdszt_sub4_1_p1:~1,3%
	if "%tdszt_sub4_1_p1:~0,1%"=="0" set tdszt_sub4_1_p1=%tdszt_sub4_1_p1:~1,2%
	set /a "tdszt_sub4_1_p1=tdszt_sub4_1_p1-1"
	call :expand4 tdszt_sub4_1_p1 %tdszt_sub4_1_p1%
	set %1=%tdszt_sub4_1_p1%
	set tdszt_sub4_1_p1=
	goto :eof

::=============================================================================
:testall
	echo Testing...
	setlocal
	set /a "ok = 0"
	set /a "bad = 0"
	set /a "tot = 0"

:test00001
	set tdszt_yyyy=aaaa
	set tdszt_mm=bb
	set tdszt_dd=cc
	set tdszt_h=dd
	set tdszt_m=ee
	set tdszt_s=ff
	call :set_now
	if not "%tdszweb_now%"=="aaaabbccddeeff" goto :test00001_bad
:test00001_ok
	set /a "ok = ok + 1"
	echo 00001.00001: okay
	goto :test00001_end
:test00001_bad
	set /a "bad = bad + 1"
	echo 00001.00001: failed, expected 'aaaabbccddeeff', got '%tdszweb_now%'
:test00001_end
	set /a "tot = tot + 1"

:test00002
	call :test00002_s1 00001 2008 01 01 aa bb cc 20071231aabbcc
	call :test00002_s1 00002 2008 02 01 aa bb cc 20080131aabbcc
	call :test00002_s1 00003 2008 03 01 aa bb cc 20080229aabbcc
	call :test00002_s1 00004 2008 04 01 aa bb cc 20080331aabbcc
	call :test00002_s1 00005 2008 05 01 aa bb cc 20080430aabbcc
	call :test00002_s1 00006 2008 06 01 aa bb cc 20080531aabbcc
	call :test00002_s1 00007 2008 07 01 aa bb cc 20080630aabbcc
	call :test00002_s1 00008 2008 08 01 aa bb cc 20080731aabbcc
	call :test00002_s1 00009 2008 09 01 aa bb cc 20080831aabbcc
	call :test00002_s1 00000 2008 10 01 aa bb cc 20080930aabbcc
	call :test00002_s1 00011 2008 11 01 aa bb cc 20081031aabbcc
	call :test00002_s1 00012 2008 12 01 aa bb cc 20081130aabbcc

	call :test00002_s1 00013 2007 03 01 aa bb cc 20070228aabbcc
	call :test00002_s1 00014 2000 03 01 aa bb cc 20000229aabbcc
	call :test00002_s1 00015 2100 03 01 aa bb cc 21000228aabbcc

	goto :test00002_end
:test00002_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_onedayago
	if not "%tdszweb_onedayago%"=="%8" goto :test00002_s1_bad
:test00002_s1_ok
	set /a "ok = ok + 1"
	echo 00002.%1: okay
	goto :test00002_s1_end
:test00002_s1_bad
	set /a "bad = bad + 1"
	echo 00002.%1: failed, expected '%8', got '%tdszweb_onedayago%'
:test00002_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00002_end

:test00003
	call :test00003_s1 00001 2008 01 01 aa bb cc 20071201aabbcc
	call :test00003_s1 00002 2008 02 01 aa bb cc 20080101aabbcc
	call :test00003_s1 00003 2008 03 01 aa bb cc 20080201aabbcc
	call :test00003_s1 00004 2008 04 01 aa bb cc 20080301aabbcc
	call :test00003_s1 00005 2008 05 01 aa bb cc 20080401aabbcc
	call :test00003_s1 00006 2008 06 01 aa bb cc 20080501aabbcc
	call :test00003_s1 00007 2008 07 01 aa bb cc 20080601aabbcc
	call :test00003_s1 00008 2008 08 01 aa bb cc 20080701aabbcc
	call :test00003_s1 00009 2008 09 01 aa bb cc 20080801aabbcc
	call :test00003_s1 00010 2008 10 01 aa bb cc 20080901aabbcc
	call :test00003_s1 00011 2008 11 01 aa bb cc 20081001aabbcc
	call :test00003_s1 00012 2008 12 01 aa bb cc 20081101aabbcc

	call :test00003_s1 00013 2008 01 31 aa bb cc 20071231aabbcc
	call :test00003_s1 00014 2008 02 29 aa bb cc 20080129aabbcc
	call :test00003_s1 00015 2008 03 31 aa bb cc 20080229aabbcc
	call :test00003_s1 00016 2008 04 30 aa bb cc 20080330aabbcc
	call :test00003_s1 00017 2008 05 31 aa bb cc 20080430aabbcc
	call :test00003_s1 00018 2008 06 30 aa bb cc 20080530aabbcc
	call :test00003_s1 00019 2008 07 31 aa bb cc 20080630aabbcc
	call :test00003_s1 00020 2008 08 31 aa bb cc 20080731aabbcc
	call :test00003_s1 00021 2008 09 30 aa bb cc 20080830aabbcc
	call :test00003_s1 00022 2008 10 31 aa bb cc 20080930aabbcc
	call :test00003_s1 00023 2008 11 30 aa bb cc 20081030aabbcc
	call :test00003_s1 00024 2008 12 31 aa bb cc 20081130aabbcc

	call :test00003_s1 00025 2008 03 30 aa bb cc 20080229aabbcc
	call :test00003_s1 00026 2008 03 29 aa bb cc 20080229aabbcc
	call :test00003_s1 00027 2008 03 28 aa bb cc 20080228aabbcc
	call :test00003_s1 00028 2007 03 30 aa bb cc 20070228aabbcc
	call :test00003_s1 00029 2007 03 29 aa bb cc 20070228aabbcc
	call :test00003_s1 00030 2007 03 28 aa bb cc 20070228aabbcc

	goto :test00003_end
:test00003_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_onemonthago
	if not "%tdszweb_onemonthago%"=="%8" goto :test00003_s1_bad
:test00003_s1_ok
	set /a "ok = ok + 1"
	echo 00003.%1: okay
	goto :test00003_s1_end
:test00003_s1_bad
	set /a "bad = bad + 1"
	echo 00003.%1: failed, expected '%8', got '%tdszweb_onemonthago%'
:test00003_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00003_end

:test00004
	call :test00004_s1 00001 1000 01 01 aa bb cc 09990101aabbcc
	call :test00004_s1 00002 1999 01 01 aa bb cc 19980101aabbcc
	call :test00004_s1 00003 2000 01 01 aa bb cc 19990101aabbcc
	call :test00004_s1 00004 2001 01 01 aa bb cc 20000101aabbcc
	call :test00004_s1 00005 2002 01 01 aa bb cc 20010101aabbcc

	call :test00004_s1 00006 2008 02 29 aa bb cc 20070228aabbcc

	goto :test00004_end
:test00004_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_oneyearago
	if not "%tdszweb_oneyearago%"=="%8" goto :test00004_s1_bad
:test00004_s1_ok
	set /a "ok = ok + 1"
	echo 00004.%1: okay
	goto :test00004_s1_end
:test00004_s1_bad
	set /a "bad = bad + 1"
	echo 00004.%1: failed, expected '%8', got '%tdszweb_oneyearago%'
:test00004_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00004_end

:test00005
	call :test00005_s1 00001 aaaa 01 bb cc dd ee aaaa0101000000
	call :test00005_s1 00002 aaaa 02 bb cc dd ee aaaa0201000000
	call :test00005_s1 00003 aaaa 03 bb cc dd ee aaaa0301000000
	call :test00005_s1 00004 aaaa 04 bb cc dd ee aaaa0401000000
	call :test00005_s1 00005 aaaa 05 bb cc dd ee aaaa0501000000
	call :test00005_s1 00006 aaaa 06 bb cc dd ee aaaa0601000000
	call :test00005_s1 00007 aaaa 07 bb cc dd ee aaaa0701000000
	call :test00005_s1 00008 aaaa 08 bb cc dd ee aaaa0801000000
	call :test00005_s1 00009 aaaa 09 bb cc dd ee aaaa0901000000
	call :test00005_s1 00010 aaaa 10 bb cc dd ee aaaa1001000000
	call :test00005_s1 00011 aaaa 11 bb cc dd ee aaaa1101000000
	call :test00005_s1 00012 aaaa 12 bb cc dd ee aaaa1201000000

	goto :test00005_end
:test00005_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_startthismonth
	if not "%tdszweb_startthismonth%"=="%8" goto :test00005_s1_bad
:test00005_s1_ok
	set /a "ok = ok + 1"
	echo 00005.%1: okay
	goto :test00005_s1_end
:test00005_s1_bad
	set /a "bad = bad + 1"
	echo 00005.%1: failed, expected '%8', got '%tdszweb_startthismonth%'
:test00005_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00005_end

:test00006
	call :test00006_s1 00001 aaaa 01 bb cc dd ee aaaa0101000000
	call :test00006_s1 00002 aaaa 02 bb cc dd ee aaaa0101000000
	call :test00006_s1 00003 aaaa 03 bb cc dd ee aaaa0101000000
	call :test00006_s1 00004 aaaa 04 bb cc dd ee aaaa0101000000
	call :test00006_s1 00005 aaaa 05 bb cc dd ee aaaa0101000000
	call :test00006_s1 00006 aaaa 06 bb cc dd ee aaaa0101000000
	call :test00006_s1 00007 aaaa 07 bb cc dd ee aaaa0101000000
	call :test00006_s1 00008 aaaa 08 bb cc dd ee aaaa0101000000
	call :test00006_s1 00009 aaaa 09 bb cc dd ee aaaa0101000000
	call :test00006_s1 00010 aaaa 10 bb cc dd ee aaaa0101000000
	call :test00006_s1 00011 aaaa 11 bb cc dd ee aaaa0101000000
	call :test00006_s1 00012 aaaa 12 bb cc dd ee aaaa0101000000

	goto :test00006_end
:test00006_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_startthisyear
	if not "%tdszweb_startthisyear%"=="%8" goto :test00006_s1_bad
:test00006_s1_ok
	set /a "ok = ok + 1"
	echo 00006.%1: okay
	goto :test00006_s1_end
:test00006_s1_bad
	set /a "bad = bad + 1"
	echo 00006.%1: failed, expected '%8', got '%tdszweb_startthisyear%'
:test00006_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00006_end

:test00007
	call :test00007_s1 00001 2008 01 bb cc dd ee 20071201000000
	call :test00007_s1 00002 2008 02 bb cc dd ee 20080101000000
	call :test00007_s1 00003 2008 03 bb cc dd ee 20080201000000
	call :test00007_s1 00004 2008 04 bb cc dd ee 20080301000000
	call :test00007_s1 00005 2008 05 bb cc dd ee 20080401000000
	call :test00007_s1 00006 2008 06 bb cc dd ee 20080501000000
	call :test00007_s1 00007 2008 07 bb cc dd ee 20080601000000
	call :test00007_s1 00008 2008 08 bb cc dd ee 20080701000000
	call :test00007_s1 00009 2008 09 bb cc dd ee 20080801000000
	call :test00007_s1 00010 2008 10 bb cc dd ee 20080901000000
	call :test00007_s1 00011 2008 11 bb cc dd ee 20081001000000
	call :test00007_s1 00012 2008 12 bb cc dd ee 20081101000000
	call :test00007_s1 00013 2009 01 bb cc dd ee 20081201000000

	goto :test00007_end
:test00007_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_startlastmonth
	if not "%tdszweb_startlastmonth%"=="%8" goto :test00007_s1_bad
:test00007_s1_ok
	set /a "ok = ok + 1"
	echo 00007.%1: okay
	goto :test00007_s1_end
:test00007_s1_bad
	set /a "bad = bad + 1"
	echo 00007.%1: failed, expected '%8', got '%tdszweb_startlastmonth%'
:test00007_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00007_end

:test00008
	call :test00008_s1 00001 2008 01 bb cc dd ee 20070101000000
	call :test00008_s1 00002 2008 02 bb cc dd ee 20070101000000
	call :test00008_s1 00003 2008 03 bb cc dd ee 20070101000000
	call :test00008_s1 00004 2008 04 bb cc dd ee 20070101000000
	call :test00008_s1 00005 2008 05 bb cc dd ee 20070101000000
	call :test00008_s1 00006 2008 06 bb cc dd ee 20070101000000
	call :test00008_s1 00007 2008 07 bb cc dd ee 20070101000000
	call :test00008_s1 00008 2008 08 bb cc dd ee 20070101000000
	call :test00008_s1 00009 2008 09 bb cc dd ee 20070101000000
	call :test00008_s1 00010 2008 10 bb cc dd ee 20070101000000
	call :test00008_s1 00011 2008 11 bb cc dd ee 20070101000000
	call :test00008_s1 00012 2008 12 bb cc dd ee 20070101000000
	call :test00008_s1 00013 2009 12 bb cc dd ee 20080101000000

	goto :test00008_end
:test00008_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_startlastyear
	if not "%tdszweb_startlastyear%"=="%8" goto :test00008_s1_bad
:test00008_s1_ok
	set /a "ok = ok + 1"
	echo 00008.%1: okay
	goto :test00008_s1_end
:test00008_s1_bad
	set /a "bad = bad + 1"
	echo 00008.%1: failed, expected '%8', got '%tdszweb_startlastyear%'
:test00008_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00008_end

:test00009
	call :test00009_s1 00001 2008 01 bb cc dd ee 20080131235959
	call :test00009_s1 00002 2008 02 bb cc dd ee 20080229235959
	call :test00009_s1 00003 2008 03 bb cc dd ee 20080331235959
	call :test00009_s1 00004 2008 04 bb cc dd ee 20080430235959
	call :test00009_s1 00005 2008 05 bb cc dd ee 20080531235959
	call :test00009_s1 00006 2008 06 bb cc dd ee 20080630235959
	call :test00009_s1 00007 2008 07 bb cc dd ee 20080731235959
	call :test00009_s1 00008 2008 08 bb cc dd ee 20080831235959
	call :test00009_s1 00009 2008 09 bb cc dd ee 20080930235959
	call :test00009_s1 00010 2008 10 bb cc dd ee 20081031235959
	call :test00009_s1 00011 2008 11 bb cc dd ee 20081130235959
	call :test00009_s1 00012 2008 12 bb cc dd ee 20081231235959
	call :test00009_s1 00013 2009 02 bb cc dd ee 20090228235959

	goto :test00009_end
:test00009_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_endthismonth
	if not "%tdszweb_endthismonth%"=="%8" goto :test00009_s1_bad
:test00009_s1_ok
	set /a "ok = ok + 1"
	echo 00009.%1: okay
	goto :test00009_s1_end
:test00009_s1_bad
	set /a "bad = bad + 1"
	echo 00009.%1: failed, expected '%8', got '%tdszweb_endthismonth%'
:test00009_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00009_end

:test00010
	call :test00010_s1 00001 aaaa bb cc dd ee ff aaaa1231235959
	call :test00010_s1 00002 bbbb cc dd ee ff gg bbbb1231235959

	goto :test00010_end
:test00010_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_endthisyear
	if not "%tdszweb_endthisyear%"=="%8" goto :test00010_s1_bad
:test00010_s1_ok
	set /a "ok = ok + 1"
	echo 00010.%1: okay
	goto :test00010_s1_end
:test00010_s1_bad
	set /a "bad = bad + 1"
	echo 00010.%1: failed, expected '%8', got '%tdszweb_endthisyear%'
:test00010_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00010_end

:test00011
	call :test00011_s1 00001 2008 01 bb cc dd ee 20071231235959
	call :test00011_s1 00002 2008 02 bb cc dd ee 20080131235959
	call :test00011_s1 00003 2008 03 bb cc dd ee 20080229235959
	call :test00011_s1 00004 2008 04 bb cc dd ee 20080331235959
	call :test00011_s1 00005 2008 05 bb cc dd ee 20080430235959
	call :test00011_s1 00006 2008 06 bb cc dd ee 20080531235959
	call :test00011_s1 00007 2008 07 bb cc dd ee 20080630235959
	call :test00011_s1 00008 2008 08 bb cc dd ee 20080731235959
	call :test00011_s1 00009 2008 09 bb cc dd ee 20080831235959
	call :test00011_s1 00010 2008 10 bb cc dd ee 20080930235959
	call :test00011_s1 00011 2008 11 bb cc dd ee 20081031235959
	call :test00011_s1 00012 2008 12 bb cc dd ee 20081130235959
	call :test00011_s1 00013 2009 03 bb cc dd ee 20090228235959

	goto :test00011_end
:test00011_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_endlastmonth
	if not "%tdszweb_endlastmonth%"=="%8" goto :test00011_s1_bad
:test00011_s1_ok
	set /a "ok = ok + 1"
	echo 00011.%1: okay
	goto :test00011_s1_end
:test00011_s1_bad
	set /a "bad = bad + 1"
	echo 00011.%1: failed, expected '%8', got '%tdszweb_endlastmonth%'
:test00011_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00011_end

:test00012
	call :test00012_s1 00001 2008 bb cc dd ee ff 20071231235959
	call :test00012_s1 00002 1000 cc dd ee ff gg 09991231235959

	goto :test00012_end
:test00012_s1
	set tdszt_yyyy=%2
	set tdszt_mm=%3
	set tdszt_dd=%4
	set tdszt_h=%5
	set tdszt_m=%6
	set tdszt_s=%7
	call :set_endlastyear
	if not "%tdszweb_endlastyear%"=="%8" goto :test00012_s1_bad
:test00012_s1_ok
	set /a "ok = ok + 1"
	echo 00012.%1: okay
	goto :test00012_s1_end
:test00012_s1_bad
	set /a "bad = bad + 1"
	echo 00012.%1: failed, expected '%8', got '%tdszweb_endlastyear%'
:test00012_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00012_end

:test00013
	call :test00013_s1 00001 2007 01 31
	call :test00013_s1 00002 2007 02 28
	call :test00013_s1 00003 2007 03 31
	call :test00013_s1 00004 2007 04 30
	call :test00013_s1 00005 2007 05 31
	call :test00013_s1 00006 2007 06 30
	call :test00013_s1 00007 2007 07 31
	call :test00013_s1 00008 2007 08 31
	call :test00013_s1 00009 2007 09 30
	call :test00013_s1 00010 2007 10 31
	call :test00013_s1 00011 2007 11 30
	call :test00013_s1 00012 2007 12 31

	call :test00013_s1 00013 2008 01 31
	call :test00013_s1 00014 2008 02 29
	call :test00013_s1 00015 2008 03 31
	call :test00013_s1 00016 2008 04 30
	call :test00013_s1 00017 2008 05 31
	call :test00013_s1 00018 2008 06 30
	call :test00013_s1 00019 2008 07 31
	call :test00013_s1 00020 2008 08 31
	call :test00013_s1 00021 2008 09 30
	call :test00013_s1 00022 2008 10 31
	call :test00013_s1 00023 2008 11 30
	call :test00013_s1 00024 2008 12 31

	call :test00013_s1 00025 1600 02 29
	call :test00013_s1 00026 1700 02 28
	call :test00013_s1 00027 1800 02 28
	call :test00013_s1 00028 1900 02 28
	call :test00013_s1 00029 1995 02 28
	call :test00013_s1 00030 1996 02 29
	call :test00013_s1 00031 1997 02 28
	call :test00013_s1 00032 1998 02 28
	call :test00013_s1 00033 1999 02 28
	call :test00013_s1 00034 2000 02 29
	call :test00013_s1 00035 2001 02 28
	call :test00013_s1 00036 2002 02 28
	call :test00013_s1 00037 2003 02 28
	call :test00013_s1 00038 2004 02 29
	call :test00013_s1 00039 2100 02 28
	call :test00013_s1 00040 2200 02 28
	call :test00013_s1 00041 2300 02 28
	call :test00013_s1 00042 2400 02 29

	goto :test00013_end
:test00013_s1
	call :daysinmonth xx %2 %3
	if not "%xx%"=="%4" goto :test00013_s1_bad
:test00013_s1_ok
	set /a "ok = ok + 1"
	echo 00013.%1: okay
	goto :test00013_s1_end
:test00013_s1_bad
	set /a "bad = bad + 1"
	echo 00013.%1: failed, expected '%4', got '%xx%'
:test00013_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00013_end

:test00014
	call :test00014_s1 00001 00
	call :test00014_s1 00002 0a a
	call :test00014_s1 00003 ab ab
	call :test00014_s1 00004 bc abc

	goto :test00014_end
:test00014_s1
	call :expand2 xx %3
	if not "%xx%"=="%2" goto :test00014_s1_bad
:test00014_s1_ok
	set /a "ok = ok + 1"
	echo 00014.%1: okay
	goto :test00014_s1_end
:test00014_s1_bad
	set /a "bad = bad + 1"
	echo 00014.%1: failed, expected '%2', got '%xx%'
:test00014_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00014_end

:test00015
	call :test00015_s1 00001 0000
	call :test00015_s1 00002 000a a
	call :test00015_s1 00003 00ab ab
	call :test00015_s1 00004 0abc abc
	call :test00015_s1 00005 abcd abcd
	call :test00015_s1 00006 bcde abcde

	goto :test00015_end
:test00015_s1
	call :expand4 xx %3
	if not "%xx%"=="%2" goto :test00015_s1_bad
:test00015_s1_ok
	set /a "ok = ok + 1"
	echo 00015.%1: okay
	goto :test00015_s1_end
:test00015_s1_bad
	set /a "bad = bad + 1"
	echo 00015.%1: failed, expected '%2', got '%xx%'
:test00015_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00015_end

:test00016
	call :test00016_s1 00001 000000
	call :test00016_s1 00002 00000a a
	call :test00016_s1 00003 0000ab ab
	call :test00016_s1 00004 000abc abc
	call :test00016_s1 00005 00abcd abcd
	call :test00016_s1 00006 0abcde abcde
	call :test00016_s1 00007 abcdef abcdef
	call :test00016_s1 00008 bcdefg abcdefg

	goto :test00016_end
:test00016_s1
	call :expand6 xx %3
	if not "%xx%"=="%2" goto :test00016_s1_bad
:test00016_s1_ok
	set /a "ok = ok + 1"
	echo 00016.%1: okay
	goto :test00016_s1_end
:test00016_s1_bad
	set /a "bad = bad + 1"
	echo 00016.%1: failed, expected '%2', got '%xx%'
:test00016_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00016_end

:test00017
	call :test00017_s1 00001 00000000
	call :test00017_s1 00002 0000000a a
	call :test00017_s1 00003 000000ab ab
	call :test00017_s1 00004 00000abc abc
	call :test00017_s1 00005 0000abcd abcd
	call :test00017_s1 00006 000abcde abcde
	call :test00017_s1 00007 00abcdef abcdef
	call :test00017_s1 00008 0abcdefg abcdefg
	call :test00017_s1 00009 abcdefgh abcdefgh
	call :test00017_s1 00010 bcdefghi abcdefghi

	goto :test00017_end
:test00017_s1
	call :expand8 xx %3
	if not "%xx%"=="%2" goto :test00017_s1_bad
:test00017_s1_ok
	set /a "ok = ok + 1"
	echo 00017.%1: okay
	goto :test00017_s1_end
:test00017_s1_bad
	set /a "bad = bad + 1"
	echo 00017.%1: failed, expected '%2', got '%xx%'
:test00017_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00017_end

:test00018
	call :test00018_s1 00001 00 1
	call :test00018_s1 00002 00 01
	call :test00018_s1 00003 00 001
	call :test00018_s1 00004 00 901

	call :test00018_s1 00005 01 2
	call :test00018_s1 00006 02 3
	call :test00018_s1 00007 03 4
	call :test00018_s1 00008 04 5
	call :test00018_s1 00009 05 6
	call :test00018_s1 00010 06 7
	call :test00018_s1 00011 07 8
	call :test00018_s1 00012 08 9
	call :test00018_s1 00013 09 10
	call :test00018_s1 00014 10 11

	goto :test00018_end
:test00018_s1
	call :sub2_1 xx %3
	if not "%xx%"=="%2" goto :test00018_s1_bad
:test00018_s1_ok
	set /a "ok = ok + 1"
	echo 00018.%1: okay
	goto :test00018_s1_end
:test00018_s1_bad
	set /a "bad = bad + 1"
	echo 00018.%1: failed, expected '%2', got '%xx%'
:test00018_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00018_end

:test00019
	call :test00019_s1 00001 0000 1
	call :test00019_s1 00002 0000 01
	call :test00019_s1 00003 0000 001
	call :test00019_s1 00004 0900 901
	call :test00019_s1 00005 0000 90001

	call :test00019_s1 00006 0001 2
	call :test00019_s1 00007 0002 3
	call :test00019_s1 00008 0003 4
	call :test00019_s1 00009 0004 5
	call :test00019_s1 00010 0005 6
	call :test00019_s1 00011 0006 7
	call :test00019_s1 00012 0007 8
	call :test00019_s1 00013 0008 9
	call :test00019_s1 00014 0009 10
	call :test00019_s1 00015 0010 11

	goto :test00019_end
:test00019_s1
	call :sub4_1 xx %3
	if not "%xx%"=="%2" goto :test00019_s1_bad
:test00019_s1_ok
	set /a "ok = ok + 1"
	echo 00019.%1: okay
	goto :test00019_s1_end
:test00019_s1_bad
	set /a "bad = bad + 1"
	echo 00019.%1: failed, expected '%2', got '%xx%'
:test00019_s1_end
	set /a "tot = tot + 1"
	goto :eof
:test00019_end

	echo Tests run: %tot%
	echo Successes: %ok%
	echo Failures:  %bad%

	endlocal
	goto :eof

